//COPYRIGHTCOPYRIGHTCOPYRIGHTCOPYRIGHTCOPYRIGHTCOPYRIGHTCOPYRIGHTCOPYRIGHT
//C                                                                      T
//C Copyright 2003 Raytheon Company                                      T
//C An unpublished work, all rights reserved.                            T
//C                                                                      T
//COPYRIGHTCOPYRIGHTCOPYRIGHTCOPYRIGHTCOPYRIGHTCOPYRIGHTCOPYRIGHTCOPYRIGHT

/*****************************************************************************

  ClientServerCombinedInterface-impl.cc - 

  This file describes the C++ implementation of the CORBA server for the
  ClientServerCombinedInterface message event.

  CVS version information
  
  Header: GEO - what should go here

*****************************************************************************/

#include "ClientServerCombinedInterface-impl.h"
#include <iostream>


//------------------------------------------------------------------------------
// Function Description:
// This function is called by the ClientServerCombinedInterface Server on the reception of a
// ClientServerCombinedInterface message.  The "push" member fuction is part of the interface
// as defined in the IDL file.
//
// Returns:
//     none
//
// Updates class data members
//  
// Parameters:
//------------------------------------------------------------------------------
NLCA::OpStatus NLCA::ClientServerCombinedInterface_impl::push (const NLCA::MyType &param)
  throw (CORBA::SystemException)
{
  int lockStatus;

  // Wait for lock
  lockStatus = pthread_mutex_lock(lockPtr);
  if (lockStatus)
  {
    std::cout << "NLCA::ClientServerCombinedInterface_impl::push failed to get lock: lockStatus = ";
    std::cout << lockStatus << std::endl;
    exit(1);
  }

  // Sync the iostreams and the C standard io
  std::cout.sync_with_stdio();

  std::cout << "param.att1 = " << param.att1 << std::endl;

  // Release lock
  lockStatus = pthread_mutex_unlock(lockPtr);
  if (lockStatus)
  {
    std::cout << "NLCA::ClientServerCombinedInterface_impl::push failed to release lock: lockStatus = ";
    std::cout << lockStatus << std::endl;
    exit(1);
  }


  return NLCA::success;

}
