#ifndef SERVERORBMANAGER_H_HEADER_INCLUDED_C032FB32
#define SERVERORBMANAGER_H_HEADER_INCLUDED_C032FB32

#include <string>
#include <iostream>
#include "NamingServiceFacade.h"

class NamingServiceFacade;

// This template class establishies a connection with the CORBA ORB and
// provides the mechanism to execute in the context of the ORBA ORB.
//##ModelId=3FCAA59D0232
template <
    // Class name of the IDL interface object.
    typename CorbaObjType,
    // The _var class name of the IDL interface. If the interface class name is
    // Navigation, then the _var class name is fromed be appending _var to the
    // class name: Navigation_var. The _var class is generated by the IDL
    // compiler. The _var class acts as a smart pointer that wraps the
    // underlying type.
    typename CorbaObjVarType,
    // The implementation class that is generated by the IDL compiler. It has
    // the format of <name space>::<name of the IDL interface>_impl. For an
    // instantiation for the Nav interface the class name is NLCA::Nav_impl.
    typename ServerImplType>
class ServerOrbManager
{
  public:
    //##ModelId=3FCAB08D02F3
    ServerOrbManager()
    {
      serverPtr = CORBA_OBJECT_NIL ;
      namingService = new NamingServiceFacade ;
    
   return ;


    }


    //##ModelId=3FCAB08D031B
    virtual ~ServerOrbManager()
    {
    }

    // This operation initializes the CORBA ORB for the sever process and uses
    // the Naming Service to register the the Server's IOR.
    //##ModelId=3FCAB10901F3
    bool initOrb(int argc, char** argv, const std::string& bindingName)
    {
        try{
            orb = CORBA::ORB_init(argc, argv, "Raytheon-Netfires");
        }
        catch(...){
            std::cout<<"Cannot initialize ORB for process"<<argv[0]<<std::endl ;
            return false ;
        }

        // Get the root POA
        CORBA::Object_var pfobj = orb->resolve_initial_references("RootPOA");
    
        PortableServer::POA_var rootPOA =
                                     PortableServer::POA::_narrow(pfobj);

        // Activate the root POA's manager
        PortableServer::POAManager_var mgr = rootPOA->the_POAManager();
        mgr->activate();

        // get Naming Service object
        namingService->resolveNamingServiceObj(orb);

        // create server object
        //ServerImplType servant ; GEO made this an attribute
        consumer = servant._this();
        CORBA_Object & serverCobj = consumer->_orbitcpp_cobj();

        // bind server object with naming service
        if(!namingService->registerWithNamingService(serverCobj, bindingName))
	{
	  std::cout<<"Failed registerWithNamingService()"<<std::endl ;
            return false ;
	}

        return true ;
    }

    // This operation pass the processing control to the CORBA ORB. Under
    // normal conditions processing control should not return from this call.
    //##ModelId=3FCAB1C203E3
    bool runOrb()
    {
      orb->run();
      return FALSE;
    }

  private:
    //##ModelId=3FCABC5C00EB
    CorbaObjVarType serverPtr;

    // Server ORB
    //##ModelId=3FCD0A840144
    CORBA::ORB_ptr orb;

    //##ModelId=3FCAB2890082
    NamingServiceFacade *namingService;

    //##ModelId=3FCD4D1700C7
    CORBA::Object_var consumer ;

    //##ModelId=3FCD4D1700F7
    ServerImplType servant ;
};



#endif /* SERVERORBMANAGER_H_HEADER_INCLUDED_C032FB32 */
