// File: ServerToolProc.cc

#include <iostream>
#include <utility>
#include <vector>
#include <unistd.h>

// ORBit2 includes
#include "orbitcpp/orb-cpp/orbitcpp.h"

#include "ClientOrbManager.h"
#include "ServerInterface-cpp-common.h"


int main (int argc, char** argv)
{
  // Set up the connection to the Server interface

  // Check if CORBA server binding name was passed as a command line
  // parameter with the format of -n "binding name" or
  // -name "binding name"
  std::vector<std::string> v;
  std::vector<std::string>::iterator vi;

  for (int i = 0; i < argc; i++)
  {
    if (argv[i] == NULL)
    {
      // end of arguments
      break;
    }
    // save the argument strings in the vector
    v.push_back(argv[i]);
  }

  // Look for the parameter in the vector
  const std::string p1Name = "-n";
  const std::string p2Name = "-name";
  std::string name = "/ServerInterface/";
  for (vi = v.begin(); vi != v.end(); vi++)
  {
    if ((*vi == p1Name) || (*vi == p2Name))
    {
      // found the name flag
      if ((vi + 1) == v.end())
      {
        // No string after the flag - use the default name
        break;
      }
      else if ((*(vi + 1))[0] == '-')
      {
        // Found another flag - use the default name
        break;
      }
      else
      {
        // Save the context name string
        name = *(vi + 1);
        break;
      }
    }
  }

  NLCA::ServerInterface_var ServerInterfacePtr ;
  ClientOrbManager<NLCA::ServerInterface, NLCA::ServerInterface_var> clientOrb;
  if (clientOrb.initOrb(argc, argv) == true)
  {
    ServerInterfacePtr = clientOrb.get_clientObj(name);
    if(ServerInterfacePtr == CORBA_OBJECT_NIL)
      {
        std::cout<<"Failed to get client server object"<<std::endl ;
        exit(1) ;
      }
  }
  else
  {
    std::cout << "ClientToolProcess: failed to connect to the Client's server.";
    std::cout << std::endl;
    return -1;
  }

  // Make a call on the CORBA interface
  CORBA::Long l = 0;
  while (1)
  {
    NLCA::MyType p;
    p.att1 = l;
    ServerInterfacePtr->push(p);
    l++;
    sleep(2);
  }

} // end main

